<!-- SPDX-License-Identifier: AGPL-3.0-or-later
     SPDX-FileCopyrightText: 2021-2024 JayVii <jayvii[AT]posteo[DOT]de> -->

<?php

// Fetch Repository Type (may only be "pub" or "prv")
$repo_type = preg_replace(
     '/[^a-z]/',
     '',
     rawurldecode(basename($_GET["type"]))
);
if ($repo_type != "pub") {
     $repo_type = "prv";
}

// Fetch Repository Name
$repo_name = preg_replace(
     '/[^a-zA-Z0-9\s\.\,\!\?\:\_\-]/',
     '',
     rawurldecode(basename($_GET["name"]))
);

// Fetch Repository Description
$repo_desc = preg_replace(
     '/[^a-zA-Z0-9\s\.\,\!\?\:\_\-]/',
     '',
     rawurldecode($_GET["description"])
);

// Fetch Repository Full Description
$repo_desc_full = preg_replace(
     '/[^a-zA-Z0-9\s\.\,\!\?\:\_\-]/',
     '',
     rawurldecode($_GET["description_full"])
);


// Fetch Repository Owner
$repo_owner = preg_replace(
     '/[^a-zA-Z0-9\s\.\,\!\?\:\_\-]/',
     '',
     rawurldecode(basename($_GET["owner"]))
);

?>

<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Create Repositories</title>
<link rel="icon" type="image/png" href="../favicon.png" />
<link rel="stylesheet" type="text/css" href="../style.css" />
</head>
<body>
<table>
<tr><td><a href="../"><img src="../assets/backicon.png" alt="Go Back" width="32" height="32" /></a></td>
<td><span class="desc">Creating a new Repository</span></td></tr><tr><td></td><td>
</td></tr>
</table>
<hr/>
<div id="content">

<?php

     # check whether all variables are set
     if ($repo_type == "" || $repo_name == "" || $repo_desc == "" || $repo_desc_full = "" || $repo_owner == "") {
          $content = "<p id=\"status\"></p>";
     } else {
          passthru(
               $_SERVER['DOCUMENT_ROOT'] . "/bin/git_create_repo.sh " .
               "\"" . $_SERVER['DOCUMENT_ROOT'] . "\" " .
               "\"" . $repo_type . "\" " .
               "\"" . $repo_name . "\" " .
               "\"" . $repo_desc . "\" " .
               "\"" . $repo_desc_full . "\" " .
               "\"" . $repo_owner . "\"",
               $response
           );
           $content = "<p id=\"status\">" . $response . "</p>";
     }

     echo $content;
?>

     <form method="GET">
          <label for="name">Repository Name</label><br>
          <input type="text" id="name" name="name" maxlength="30" placeholder="my_new_project" default=<?php echo "\"" . $repo_name . "\""; ?> required><br>
          <label for="description">Repository Description</label><br>
          <input type="text" id="description" name="description" maxlength="100" placeholder="This project is about..." default=<?php echo "\"" . $repo_desc . "\""; ?> required><br>
          <label for="description_full">Long Description of the Repository</label><br>
          <textarea id="description_full" name="description_full" style="min-height:150px;" required></textarea><br>
          <label for="owner" >Repository Owner</label><br>
          <input type="text" id="owner" name="owner" maxlength="30" placeholder="Me" default=<?php echo "\"" . $repo_owner . "\""; ?> required><br>
          <label for="type">Repository Type</label><br>
          <select name="type" required>
               <option value="prv" selected>Private</option>
               <option value="pub">Public</option>
          </select><br><br>
          <input type="submit" value="Submit">
     </form>
</div>
</body>
</html>
